/etc/init.d/globus-scheduler-event-generator is in globus-scheduler-event-generator-progs 5.7-3.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 | #! /bin/sh
#
# globus-scheduler-event-generator - Globus Scheduler Event Generator
#
# chkconfig: 2345 20 80
# description: Parse LRM events into a common log format \
# for the GRAM job manager to use
### BEGIN INIT INFO
# Provides: globus-scheduler-event-generator
# Required-Start: $remote_fs $time
# Required-Stop: $remote_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Globus Scheduler Event Generator
# Description: The Globus Scheduler Event Generator service
# process state from local resource managers (such as
# torque or SGE) into a form that the globus-job-manager
# process can easily parse.
# It is part of the Globus Toolkit(tm)
### END INIT INFO
# Copyright 1999-2011 University of Chicago
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
sbindir=/usr/sbin
localstatedir=/var
sysconfdir=/etc
progname=globus-scheduler-event-generator
prog=${sbindir}/${progname}
test -f /etc/default/${progname} && . /etc/default/${progname}
test -f ${prog} || exit 0
lockfile=/var/lock/${progname}
GLOBUS_SEG_LRM_DIR="${GLOBUS_SEG_LRM_DIR:-/etc/globus/scheduler-event-generator}"
full=1
if [ -n "$2" ]; then
full=0
fi
for lrm in "${GLOBUS_SEG_LRM_DIR}"/*; do
if [ -n "$2" -a "$(basename "$lrm")" != "$2" ]; then
continue
fi
if [ -f "$lrm" ]; then
lrms="${lrms:+$lrms }$(basename $lrm)"
fi
done
GLOBUS_SEG_PIDFMT="${GLOBUS_SEG_PIDFMT:-/var/run/${progname}-%s.pid}"
GLOBUS_SEG_LOGFMT="${GLOBUS_SEG_LOGFMT:-/var/log/globus/globus-seg-%s}"
start()
{
allrc=0
started=""
failed=""
for lrm in $lrms; do
pidfile="$(printf "$GLOBUS_SEG_PIDFMT" "$lrm")"
logdir="$(printf "$GLOBUS_SEG_LOGFMT" "$lrm")"
status $lrm > /dev/null
rc=$?
if [ $rc -eq 0 ]; then
continue
fi
if [ ! -d "$logdir" ]; then
(umask 022; mkdir "$logdir")
fi
${GLOBUS_SEG_NICE_LEVEL:+nice -n "${GLOBUS_SEG_NICE_LEVEL}"} \
"${prog}" \
-s "$lrm" \
-p "$pidfile" \
-d "$logdir" \
-b > /dev/null
rc=$?
if [ $rc = 0 ]; then
started="${started:+${started}, }$lrm"
else
failed="${failed:+${failed}, }$lrm"
allrc=$rc
fi
done
if [ "$allrc" -eq 0 -a "$lrms" != "" ]; then
echo "Started ${progname}${started:+ for ($started)}"
touch "$lockfile"
elif [ "$allrc" -eq 0 ]; then
echo "$progname: no LRMS installed"
elif [ "$started" = "" ]; then
echo "Failed to start ${progname} for ($failed)"
else
echo "Some problems starting ${progname} for ($failed), but ($started) were ok"
touch "$lockfile"
fi
return $allrc
}
stop()
{
allrc=0
stopped=""
failed=""
for lrm in $lrms; do
pidfile="$(printf "$GLOBUS_SEG_PIDFMT" "$lrm")"
logdir="$(printf "$GLOBUS_SEG_LOGFMT" "$lrm")"
if [ -f "$pidfile" ]; then
read pid < "${pidfile}" 2> /dev/null
if [ "$pid" -gt 0 ] 2>/dev/null; then
if kill -0 "${pid}" 2> /dev/null; then
kill -TERM "${pid}"
if sleep 1 && kill -0 "${pid}" 2>/dev/null && \
sleep 3 && kill -0 "${pid}" 2>/dev/null; then
kill -KILL "${pid}"
fi
if kill -0 "${pid}" 2> /dev/null; then
failed="${failed:+$failed, }$lrm"
allrc=1
continue
fi
fi
fi
stopped="${stopped:+${stopped}, }$lrm"
rm -f "${pidfile}"
fi
done
if [ "$allrc" -eq 0 ]; then
echo "Stopped ${progname}${stopped:+ for ($stopped)}"
if [ "$full" -eq 1 ]; then
rm -f "$lockfile"
fi
elif [ "$stopped" = "" ]; then
echo "Failed to stop ${progname} for $failed"
else
echo "Some problems stopping ${progname} for $failed, but $stopped were ok"
fi
return $allrc
}
restart()
{
stop
start
}
status()
{
_lrms="$1"
running=0
stale=0
nopidfile=0
if [ "$_lrms" = "" ]; then
_lrms="$lrms"
fi
for lrm in $_lrms; do
pidfile="$(printf "$GLOBUS_SEG_PIDFMT" "$lrm")"
if [ -f "$pidfile" ]; then
read pid < "$pidfile" 2>/dev/null
if [ "$pid" -gt 0 ] 2>/dev/null; then
if ps -p "$pid" > /dev/null; then
echo "$progname ($lrm) is running (pid=$pid)"
running=1
else
echo "Stale PID file for $progname ($lrm)"
stale=1
fi
fi
else
echo "$progname ($lrm) is not running"
fi
done
if [ "$stale" -ne 0 ]; then
return 1
fi
if [ "$running" -eq 0 -a "$stale" -eq 0 -a "${lrms}" != "" -a -f "${lockfile}" ]; then
echo "Stale lock file for $progname"
return 2
fi
if [ "$running" -eq 1 ]; then
return 0
else
echo "$progname not running, no LRMs installed"
return 3
fi
}
case "$1" in
start)
start
;;
stop)
stop
;;
restart)
restart
;;
reload)
exit 0
;;
force-reload)
restart
;;
status)
status
;;
condrestart|try-restart)
status || exit 0
restart
;;
*)
echo "Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload}"
exit 2
;;
esac
|